from __future__ import division
from scipy import *
from math import *
import Gnuplot

titre = "champ--yy"

def phi(x,y):
	return -y*y

xmin = -5
xmax = 5
ymin = -5
ymax = 5
nbx = 21
nby = 21

deltax = (xmax-xmin)/nbx

def frange(min, max, n):
	L = [0] * n
	nm1 = n - 1
	nm1inv = 1/nm1
	for i in range(n):
		L[i] = nm1inv * (min*(nm1 - i) + max*i)
	return L

gp = Gnuplot.Gnuplot(persist=1)


data=[]

for cx in frange(xmin, xmax, nbx):
	for cy in frange(ymin, ymax, nby):
		cphi = phi(cx,cy)
		dx = deltax/2/sqrt(1+cphi**2)
		dy = deltax/2*cphi/sqrt(1+cphi**2)
		data.append([cx - dx/2, cy -dy/2, dx, dy])
		# Each data entry has the form [x, y, u, v]
plot1 = Gnuplot.PlotItems.Data(data, with_='vectors nohead')
#gp('set border 0')
#gp('unset xtics')
#gp('unset ytics')
#gp('set yrange [-6:6]')
gp('set grid')
gp('set size square ')
gp.plot(plot1)
gp.hardcopy(filename=titre+".ps",terminal="postscript")

